Index: branches/GP-MoveOperators/HeuristicLab.Encodings.IntegerVectorEncoding/3.3/BoundedIntegerVectorCrossover.cs
===================================================================
--- branches/GP-MoveOperators/HeuristicLab.Encodings.IntegerVectorEncoding/3.3/BoundedIntegerVectorCrossover.cs	(revision 8085)
+++ branches/GP-MoveOperators/HeuristicLab.Encodings.IntegerVectorEncoding/3.3/BoundedIntegerVectorCrossover.cs	(revision 8206)
@@ -50,14 +50,4 @@
 
     protected abstract IntegerVector CrossBounded(IRandom random, ItemArray<IntegerVector> parents, IntMatrix bounds);
-
-    protected static int RoundFeasible(int min, int max, int step, double value) {
-      return Math.Max(min, Math.Min(max, (int)Math.Round((value - min) / (double)step) * step + min));
-    }
-    protected static int FloorFeasible(int min, int max, int step, double value) {
-      return Math.Max(min, Math.Min(max, (int)Math.Floor((value - min) / (double)step) * step + min));
-    }
-    protected static int CeilingFeasible(int min, int max, int step, double value) {
-      return Math.Max(min, Math.Min(max, (int)Math.Ceiling((value - min) / (double)step) * step + min));
-    }
   }
 }
Index: branches/GP-MoveOperators/HeuristicLab.Encodings.IntegerVectorEncoding/3.3/BoundedIntegerVectorManipulator.cs
===================================================================
--- branches/GP-MoveOperators/HeuristicLab.Encodings.IntegerVectorEncoding/3.3/BoundedIntegerVectorManipulator.cs	(revision 8085)
+++ branches/GP-MoveOperators/HeuristicLab.Encodings.IntegerVectorEncoding/3.3/BoundedIntegerVectorManipulator.cs	(revision 8206)
@@ -31,5 +31,5 @@
   [StorableClass]
   public abstract class BoundedIntegerVectorManipulator : IntegerVectorManipulator, IBoundedIntegerVectorOperator {
-    
+
     public IValueLookupParameter<IntMatrix> BoundsParameter {
       get { return (IValueLookupParameter<IntMatrix>)Parameters["Bounds"]; }
@@ -45,19 +45,9 @@
 
     protected sealed override void Manipulate(IRandom random, IntegerVector integerVector) {
-      if (BoundsParameter.ActualValue == null) throw new InvalidOperationException("UniformSomePositionsManipulator: Parameter " + BoundsParameter.ActualName + " could not be found.");
+      if (BoundsParameter.ActualValue == null) throw new InvalidOperationException("BoundedIntegerVectorManipulator: Parameter " + BoundsParameter.ActualName + " could not be found.");
       ManipulateBounded(random, integerVector, BoundsParameter.ActualValue);
     }
 
     protected abstract void ManipulateBounded(IRandom random, IntegerVector integerVector, IntMatrix bounds);
-
-    protected static int RoundFeasible(int min, int max, int step, double value) {
-      return Math.Max(min, Math.Min(max, (int)Math.Round((value - min) / (double)step) * step + min));
-    }
-    protected static int FloorFeasible(int min, int max, int step, double value) {
-      return Math.Max(min, Math.Min(max, (int)Math.Floor((value - min) / (double)step) * step + min));
-    }
-    protected static int CeilingFeasible(int min, int max, int step, double value) {
-      return Math.Max(min, Math.Min(max, (int)Math.Ceiling((value - min) / (double)step) * step + min));
-    }
   }
 }
Index: branches/GP-MoveOperators/HeuristicLab.Encodings.IntegerVectorEncoding/3.3/Creators/UniformRandomIntegerVectorCreator.cs
===================================================================
--- branches/GP-MoveOperators/HeuristicLab.Encodings.IntegerVectorEncoding/3.3/Creators/UniformRandomIntegerVectorCreator.cs	(revision 8085)
+++ branches/GP-MoveOperators/HeuristicLab.Encodings.IntegerVectorEncoding/3.3/Creators/UniformRandomIntegerVectorCreator.cs	(revision 8206)
@@ -46,6 +46,6 @@
     /// <param name="random">The random number generator.</param>
     /// <param name="length">The length of the int vector.</param>
-    /// <param name="min">The minimum value of the sampling range for each vector element (inclusive).</param>
-    /// <param name="max">The maximum value of the sampling range for each vector element (exclusive).</param>
+    /// <param name="bounds">A matrix containing the inclusive lower and inclusive upper bound in the first and second column and a step size in the third column.
+    /// Each line represents the bounds for a certain dimension. If fewer lines are given, the lines are cycled.</param>
     /// <returns>The newly created integer vector.</returns>
     public static IntegerVector Apply(IRandom random, int length, IntMatrix bounds) {
Index: branches/GP-MoveOperators/HeuristicLab.Encodings.IntegerVectorEncoding/3.3/HeuristicLab.Encodings.IntegerVectorEncoding-3.3.csproj
===================================================================
--- branches/GP-MoveOperators/HeuristicLab.Encodings.IntegerVectorEncoding/3.3/HeuristicLab.Encodings.IntegerVectorEncoding-3.3.csproj	(revision 8085)
+++ branches/GP-MoveOperators/HeuristicLab.Encodings.IntegerVectorEncoding/3.3/HeuristicLab.Encodings.IntegerVectorEncoding-3.3.csproj	(revision 8206)
@@ -122,4 +122,5 @@
     </Compile>
     <Compile Include="Crossovers\RoundedUniformArithmeticCrossover.cs" />
+    <Compile Include="IntegerVectorOperator.cs" />
     <Compile Include="Interfaces\IBoundedIntegerVectorOperator.cs" />
     <Compile Include="Interfaces\IIntegerVectorCreator.cs" />
@@ -137,7 +138,7 @@
     <Compile Include="Manipulators\RoundedNormalAllPositionsManipulator.cs" />
     <Compile Include="Manipulators\SelfAdaptiveRoundedNormalAllPositionsManipulator.cs" />
-    <Compile Include="Manipulators\StdDevStrategyVectorCreator.cs" />
-    <Compile Include="Manipulators\StdDevStrategyVectorCrossover.cs" />
-    <Compile Include="Manipulators\StdDevStrategyVectorManipulator.cs" />
+    <Compile Include="StrategyParameters\StdDevStrategyVectorCreator.cs" />
+    <Compile Include="StrategyParameters\StdDevStrategyVectorCrossover.cs" />
+    <Compile Include="StrategyParameters\StdDevStrategyVectorManipulator.cs" />
     <Compile Include="Manipulators\UniformOnePositionManipulator.cs">
       <SubType>Code</SubType>
Index: branches/GP-MoveOperators/HeuristicLab.Encodings.IntegerVectorEncoding/3.3/IntegerVectorCrossover.cs
===================================================================
--- branches/GP-MoveOperators/HeuristicLab.Encodings.IntegerVectorEncoding/3.3/IntegerVectorCrossover.cs	(revision 8085)
+++ branches/GP-MoveOperators/HeuristicLab.Encodings.IntegerVectorEncoding/3.3/IntegerVectorCrossover.cs	(revision 8206)
@@ -22,5 +22,4 @@
 using HeuristicLab.Common;
 using HeuristicLab.Core;
-using HeuristicLab.Operators;
 using HeuristicLab.Optimization;
 using HeuristicLab.Parameters;
@@ -33,5 +32,5 @@
   [Item("IntegerVectorCrossover", "A base class for operators that perform a crossover of int-valued vectors.")]
   [StorableClass]
-  public abstract class IntegerVectorCrossover : SingleSuccessorOperator, IIntegerVectorCrossover, IStochasticOperator {
+  public abstract class IntegerVectorCrossover : IntegerVectorOperator, IIntegerVectorCrossover, IStochasticOperator {
     public override bool CanChangeName {
       get { return false; }
Index: branches/GP-MoveOperators/HeuristicLab.Encodings.IntegerVectorEncoding/3.3/IntegerVectorManipulator.cs
===================================================================
--- branches/GP-MoveOperators/HeuristicLab.Encodings.IntegerVectorEncoding/3.3/IntegerVectorManipulator.cs	(revision 8085)
+++ branches/GP-MoveOperators/HeuristicLab.Encodings.IntegerVectorEncoding/3.3/IntegerVectorManipulator.cs	(revision 8206)
@@ -22,5 +22,4 @@
 using HeuristicLab.Common;
 using HeuristicLab.Core;
-using HeuristicLab.Operators;
 using HeuristicLab.Optimization;
 using HeuristicLab.Parameters;
@@ -33,5 +32,5 @@
   [Item("IntegerVectorManipulator", "A base class for operators that manipulate int-valued vectors.")]
   [StorableClass]
-  public abstract class IntegerVectorManipulator : SingleSuccessorOperator, IIntegerVectorManipulator, IStochasticOperator {
+  public abstract class IntegerVectorManipulator : IntegerVectorOperator, IIntegerVectorManipulator, IStochasticOperator {
     public override bool CanChangeName {
       get { return false; }
Index: branches/GP-MoveOperators/HeuristicLab.Encodings.IntegerVectorEncoding/3.3/IntegerVectorOperator.cs
===================================================================
--- branches/GP-MoveOperators/HeuristicLab.Encodings.IntegerVectorEncoding/3.3/IntegerVectorOperator.cs	(revision 8206)
+++ branches/GP-MoveOperators/HeuristicLab.Encodings.IntegerVectorEncoding/3.3/IntegerVectorOperator.cs	(revision 8206)
@@ -0,0 +1,48 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Operators;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Encodings.IntegerVectorEncoding {
+  [Item("IntegerVectorOperator", "Base class for integer vectoro operators.")]
+  [StorableClass]
+  public abstract class IntegerVectorOperator : SingleSuccessorOperator, IIntegerVectorOperator {
+
+    [StorableConstructor]
+    protected IntegerVectorOperator(bool deserializing) : base(deserializing) { }
+    protected IntegerVectorOperator(IntegerVectorOperator original, Cloner cloner) : base(original, cloner) { }
+    public IntegerVectorOperator() : base() { }
+
+    public static int RoundFeasible(int min, int max, int step, double value) {
+      return Math.Max(min, Math.Min(max, (int)Math.Round((value - min) / (double)step) * step + min));
+    }
+    public static int FloorFeasible(int min, int max, int step, double value) {
+      return Math.Max(min, Math.Min(max, (int)Math.Floor((value - min) / (double)step) * step + min));
+    }
+    public static int CeilingFeasible(int min, int max, int step, double value) {
+      return Math.Max(min, Math.Min(max, (int)Math.Ceiling((value - min) / (double)step) * step + min));
+    }
+  }
+}
Index: branches/GP-MoveOperators/HeuristicLab.Encodings.IntegerVectorEncoding/3.3/Manipulators/StdDevStrategyVectorCreator.cs
===================================================================
--- branches/GP-MoveOperators/HeuristicLab.Encodings.IntegerVectorEncoding/3.3/Manipulators/StdDevStrategyVectorCreator.cs	(revision 8085)
+++ 	(revision )
@@ -1,78 +1,0 @@
-﻿#region License Information
-/* HeuristicLab
- * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
- *
- * This file is part of HeuristicLab.
- *
- * HeuristicLab is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * HeuristicLab is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
- */
-#endregion
-
-using HeuristicLab.Common;
-using HeuristicLab.Core;
-using HeuristicLab.Data;
-using HeuristicLab.Operators;
-using HeuristicLab.Optimization;
-using HeuristicLab.Parameters;
-using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
-
-namespace HeuristicLab.Encodings.IntegerVectorEncoding {
-  [Item("StdDevStrategyVectorCreator", "Creates the endogeneous strategy parameters.")]
-  [StorableClass]
-  public class StdDevStrategyVectorCreator : SingleSuccessorOperator, IStochasticOperator, IIntegerVectorStdDevStrategyParameterCreator {
-    public override bool CanChangeName {
-      get { return false; }
-    }
-    public ILookupParameter<IRandom> RandomParameter {
-      get { return (LookupParameter<IRandom>)Parameters["Random"]; }
-    }
-    public ILookupParameter<DoubleArray> StrategyParameterParameter {
-      get { return (ILookupParameter<DoubleArray>)Parameters["StrategyParameter"]; }
-    }
-    public IValueLookupParameter<IntValue> LengthParameter {
-      get { return (IValueLookupParameter<IntValue>)Parameters["Length"]; }
-    }
-    public IValueLookupParameter<DoubleMatrix> BoundsParameter {
-      get { return (IValueLookupParameter<DoubleMatrix>)Parameters["Bounds"]; }
-    }
-
-    [StorableConstructor]
-    protected StdDevStrategyVectorCreator(bool deserializing) : base(deserializing) { }
-    protected StdDevStrategyVectorCreator(StdDevStrategyVectorCreator original, Cloner cloner) : base(original, cloner) { }
-    public StdDevStrategyVectorCreator()
-      : base() {
-      Parameters.Add(new LookupParameter<IRandom>("Random", "The random number generator to use."));
-      Parameters.Add(new LookupParameter<DoubleArray>("StrategyParameter", "The crossed strategy parameter."));
-      Parameters.Add(new ValueLookupParameter<IntValue>("Length", "The length of the vector."));
-      Parameters.Add(new ValueLookupParameter<DoubleMatrix>("Bounds", "A 2 column matrix specifying the lower and upper bound for each dimension. If there are less rows than dimension the bounds vector is cycled.", new DoubleMatrix(new double[,] { { 0, 5 } })));
-    }
-
-    public override IDeepCloneable Clone(Cloner cloner) {
-      return new StdDevStrategyVectorCreator(this, cloner);
-    }
-
-    public override IOperation Apply() {
-      StrategyParameterParameter.ActualValue = Randomize(RandomParameter.ActualValue, LengthParameter.ActualValue.Value, BoundsParameter.ActualValue);
-      return base.Apply();
-    }
-
-    private DoubleArray Randomize(IRandom random, int length, DoubleMatrix bounds) {
-      var result = new DoubleArray(length);
-      for (int i = 0; i < length; i++) {
-        result[i] = random.NextDouble() * bounds[i % bounds.Rows, 1] - bounds[i % bounds.Rows, 0];
-      }
-      return result;
-    }
-  }
-}
Index: branches/GP-MoveOperators/HeuristicLab.Encodings.IntegerVectorEncoding/3.3/Manipulators/StdDevStrategyVectorCrossover.cs
===================================================================
--- branches/GP-MoveOperators/HeuristicLab.Encodings.IntegerVectorEncoding/3.3/Manipulators/StdDevStrategyVectorCrossover.cs	(revision 8085)
+++ 	(revision )
@@ -1,79 +1,0 @@
-﻿#region License Information
-/* HeuristicLab
- * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
- *
- * This file is part of HeuristicLab.
- *
- * HeuristicLab is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * HeuristicLab is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
- */
-#endregion
-
-using HeuristicLab.Common;
-using HeuristicLab.Core;
-using HeuristicLab.Data;
-using HeuristicLab.Operators;
-using HeuristicLab.Optimization;
-using HeuristicLab.Parameters;
-using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
-
-namespace HeuristicLab.Encodings.IntegerVectorEncoding {
-  [Item("StdDevStrategyVectorCrossover", "Crosses the strategy vector by using intermediate recombination (average crossover).")]
-  [StorableClass]
-  public class StdDevStrategyVectorCrossover : SingleSuccessorOperator, IStochasticOperator, IIntegerVectorStdDevStrategyParameterCrossover {
-    public override bool CanChangeName {
-      get { return false; }
-    }
-    public ILookupParameter<IRandom> RandomParameter {
-      get { return (ILookupParameter<IRandom>)Parameters["Random"]; }
-    }
-    public ILookupParameter<ItemArray<DoubleArray>> ParentsParameter {
-      get { return (ILookupParameter<ItemArray<DoubleArray>>)Parameters["ParentStrategyParameter"]; }
-    }
-    public ILookupParameter<DoubleArray> StrategyParameterParameter {
-      get { return (ILookupParameter<DoubleArray>)Parameters["StrategyParameter"]; }
-    }
-
-    [StorableConstructor]
-    protected StdDevStrategyVectorCrossover(bool deserializing) : base(deserializing) { }
-    protected StdDevStrategyVectorCrossover(StdDevStrategyVectorCrossover original, Cloner cloner) : base(original, cloner) { }
-    public StdDevStrategyVectorCrossover()
-      : base() {
-      Parameters.Add(new LookupParameter<IRandom>("Random", "The random number generator to use."));
-      Parameters.Add(new ScopeTreeLookupParameter<DoubleArray>("ParentStrategyParameter", "The strategy parameters to cross."));
-      Parameters.Add(new LookupParameter<DoubleArray>("StrategyParameter", "The crossed strategy parameter."));
-      ParentsParameter.ActualName = "StrategyParameter";
-    }
-
-    public override IDeepCloneable Clone(Cloner cloner) {
-      return new StdDevStrategyVectorCrossover(this, cloner);
-    }
-
-    public override IOperation Apply() {
-      StrategyParameterParameter.ActualValue = Average(RandomParameter.ActualValue, ParentsParameter.ActualValue);
-      return base.Apply();
-    }
-
-    private DoubleArray Average(IRandom random, ItemArray<DoubleArray> parents) {
-      int length = parents[0].Length;
-      var result = new DoubleArray(length);
-      for (int i = 0; i < length; i++) {
-        for (int p = 0; p < parents.Length; p++) {
-          result[i] += parents[p][i];
-        }
-        result[i] /= parents.Length;
-      }
-      return result;
-    }
-  }
-}
Index: branches/GP-MoveOperators/HeuristicLab.Encodings.IntegerVectorEncoding/3.3/Manipulators/StdDevStrategyVectorManipulator.cs
===================================================================
--- branches/GP-MoveOperators/HeuristicLab.Encodings.IntegerVectorEncoding/3.3/Manipulators/StdDevStrategyVectorManipulator.cs	(revision 8085)
+++ 	(revision )
@@ -1,113 +1,0 @@
-﻿#region License Information
-/* HeuristicLab
- * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
- *
- * This file is part of HeuristicLab.
- *
- * HeuristicLab is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * HeuristicLab is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
- */
-#endregion
-
-using System;
-using HeuristicLab.Common;
-using HeuristicLab.Core;
-using HeuristicLab.Data;
-using HeuristicLab.Operators;
-using HeuristicLab.Optimization;
-using HeuristicLab.Parameters;
-using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
-using HeuristicLab.Random;
-
-namespace HeuristicLab.Encodings.IntegerVectorEncoding {
-  /// <summary>
-  /// Mutates the endogenous strategy parameters.
-  /// </summary>
-  [Item("StdDevStrategyVectorManipulator", "Mutates the endogenous strategy parameters.")]
-  [StorableClass]
-  public class StdDevStrategyVectorManipulator : SingleSuccessorOperator, IStochasticOperator, IIntegerVectorStdDevStrategyParameterManipulator {
-    public override bool CanChangeName {
-      get { return false; }
-    }
-    public ILookupParameter<IRandom> RandomParameter {
-      get { return (ILookupParameter<IRandom>)Parameters["Random"]; }
-    }
-    public ILookupParameter<DoubleArray> StrategyParameterParameter {
-      get { return (ILookupParameter<DoubleArray>)Parameters["StrategyParameter"]; }
-    }
-    public IValueLookupParameter<DoubleValue> GeneralLearningRateParameter {
-      get { return (IValueLookupParameter<DoubleValue>)Parameters["GeneralLearningRate"]; }
-    }
-    public IValueLookupParameter<DoubleValue> LearningRateParameter {
-      get { return (IValueLookupParameter<DoubleValue>)Parameters["LearningRate"]; }
-    }
-    public IValueLookupParameter<DoubleMatrix> BoundsParameter {
-      get { return (IValueLookupParameter<DoubleMatrix>)Parameters["Bounds"]; }
-    }
-
-    [StorableConstructor]
-    protected StdDevStrategyVectorManipulator(bool deserializing) : base(deserializing) { }
-    protected StdDevStrategyVectorManipulator(StdDevStrategyVectorManipulator original, Cloner cloner) : base(original, cloner) { }
-    public StdDevStrategyVectorManipulator()
-      : base() {
-      Parameters.Add(new LookupParameter<IRandom>("Random", "The random number generator to use."));
-      Parameters.Add(new LookupParameter<DoubleArray>("StrategyParameter", "The strategy parameter to manipulate."));
-      Parameters.Add(new ValueLookupParameter<DoubleValue>("GeneralLearningRate", "The general learning rate (tau0)."));
-      Parameters.Add(new ValueLookupParameter<DoubleValue>("LearningRate", "The learning rate (tau)."));
-      Parameters.Add(new ValueLookupParameter<DoubleMatrix>("Bounds", "A 2 column matrix specifying the lower and upper bound for each dimension. If there are less rows than dimension the bounds vector is cycled.", new DoubleMatrix(new double[,] { { 0, 5 } })));
-    }
-
-    public override IDeepCloneable Clone(Cloner cloner) {
-      return new StdDevStrategyVectorManipulator(this, cloner);
-    }
-
-    /// <summary>
-    /// Mutates the endogenous strategy parameters.
-    /// </summary>
-    /// <param name="random">The random number generator to use.</param>
-    /// <param name="vector">The strategy vector to manipulate.</param>
-    /// <param name="generalLearningRate">The general learning rate dampens the mutation over all dimensions.</param>
-    /// <param name="learningRate">The learning rate dampens the mutation in each dimension.</param>
-    /// <param name="bounds">The minimal and maximal value for each component, bounds are cycled if the length of bounds is smaller than the length of vector</param>
-    public static void Apply(IRandom random, DoubleArray vector, double generalLearningRate, double learningRate, DoubleMatrix bounds) {
-      NormalDistributedRandom N = new NormalDistributedRandom(random, 0.0, 1.0);
-      double generalMultiplier = Math.Exp(generalLearningRate * N.NextDouble());
-      for (int i = 0; i < vector.Length; i++) {
-        double change = vector[i] * generalMultiplier * Math.Exp(learningRate * N.NextDouble());
-        if (bounds != null) {
-          double min = bounds[i % bounds.Rows, 0], max = bounds[i % bounds.Rows, 1];
-          if (min == max) vector[i] = min;
-          else {
-            if (change < min || change > max) change = Math.Max(min, Math.Min(max, change));
-            vector[i] = change;
-          }
-        }
-      }
-    }
-    /// <summary>
-    /// Mutates the endogenous strategy parameters.
-    /// </summary>
-    /// <remarks>Calls <see cref="OperatorBase.Apply"/> of base class <see cref="OperatorBase"/>.</remarks>
-    /// <inheritdoc select="returns"/>
-    public override IOperation Apply() {
-      var strategyParams = StrategyParameterParameter.ActualValue;
-      if (strategyParams != null) { // only apply if there is a strategy vector
-        IRandom random = RandomParameter.ActualValue;
-        double tau0 = GeneralLearningRateParameter.ActualValue.Value;
-        double tau = LearningRateParameter.ActualValue.Value;
-        Apply(random, strategyParams, tau0, tau, BoundsParameter.ActualValue);
-      }
-      return base.Apply();
-    }
-  }
-}
Index: branches/GP-MoveOperators/HeuristicLab.Encodings.IntegerVectorEncoding/3.3/StrategyParameters/StdDevStrategyVectorCreator.cs
===================================================================
--- branches/GP-MoveOperators/HeuristicLab.Encodings.IntegerVectorEncoding/3.3/StrategyParameters/StdDevStrategyVectorCreator.cs	(revision 8206)
+++ branches/GP-MoveOperators/HeuristicLab.Encodings.IntegerVectorEncoding/3.3/StrategyParameters/StdDevStrategyVectorCreator.cs	(revision 8206)
@@ -0,0 +1,78 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Operators;
+using HeuristicLab.Optimization;
+using HeuristicLab.Parameters;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Encodings.IntegerVectorEncoding {
+  [Item("StdDevStrategyVectorCreator", "Creates the endogeneous strategy parameters.")]
+  [StorableClass]
+  public class StdDevStrategyVectorCreator : SingleSuccessorOperator, IStochasticOperator, IIntegerVectorStdDevStrategyParameterCreator {
+    public override bool CanChangeName {
+      get { return false; }
+    }
+    public ILookupParameter<IRandom> RandomParameter {
+      get { return (LookupParameter<IRandom>)Parameters["Random"]; }
+    }
+    public ILookupParameter<DoubleArray> StrategyParameterParameter {
+      get { return (ILookupParameter<DoubleArray>)Parameters["StrategyParameter"]; }
+    }
+    public IValueLookupParameter<IntValue> LengthParameter {
+      get { return (IValueLookupParameter<IntValue>)Parameters["Length"]; }
+    }
+    public IValueLookupParameter<DoubleMatrix> BoundsParameter {
+      get { return (IValueLookupParameter<DoubleMatrix>)Parameters["Bounds"]; }
+    }
+
+    [StorableConstructor]
+    protected StdDevStrategyVectorCreator(bool deserializing) : base(deserializing) { }
+    protected StdDevStrategyVectorCreator(StdDevStrategyVectorCreator original, Cloner cloner) : base(original, cloner) { }
+    public StdDevStrategyVectorCreator()
+      : base() {
+      Parameters.Add(new LookupParameter<IRandom>("Random", "The random number generator to use."));
+      Parameters.Add(new LookupParameter<DoubleArray>("StrategyParameter", "The crossed strategy parameter."));
+      Parameters.Add(new ValueLookupParameter<IntValue>("Length", "The length of the vector."));
+      Parameters.Add(new ValueLookupParameter<DoubleMatrix>("Bounds", "A 2 column matrix specifying the lower and upper bound for each dimension. If there are less rows than dimension the bounds vector is cycled.", new DoubleMatrix(new double[,] { { 0, 5 } })));
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new StdDevStrategyVectorCreator(this, cloner);
+    }
+
+    public override IOperation Apply() {
+      StrategyParameterParameter.ActualValue = Randomize(RandomParameter.ActualValue, LengthParameter.ActualValue.Value, BoundsParameter.ActualValue);
+      return base.Apply();
+    }
+
+    private DoubleArray Randomize(IRandom random, int length, DoubleMatrix bounds) {
+      var result = new DoubleArray(length);
+      for (int i = 0; i < length; i++) {
+        result[i] = random.NextDouble() * bounds[i % bounds.Rows, 1] - bounds[i % bounds.Rows, 0];
+      }
+      return result;
+    }
+  }
+}
Index: branches/GP-MoveOperators/HeuristicLab.Encodings.IntegerVectorEncoding/3.3/StrategyParameters/StdDevStrategyVectorCrossover.cs
===================================================================
--- branches/GP-MoveOperators/HeuristicLab.Encodings.IntegerVectorEncoding/3.3/StrategyParameters/StdDevStrategyVectorCrossover.cs	(revision 8206)
+++ branches/GP-MoveOperators/HeuristicLab.Encodings.IntegerVectorEncoding/3.3/StrategyParameters/StdDevStrategyVectorCrossover.cs	(revision 8206)
@@ -0,0 +1,79 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Operators;
+using HeuristicLab.Optimization;
+using HeuristicLab.Parameters;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Encodings.IntegerVectorEncoding {
+  [Item("StdDevStrategyVectorCrossover", "Crosses the strategy vector by using intermediate recombination (average crossover).")]
+  [StorableClass]
+  public class StdDevStrategyVectorCrossover : SingleSuccessorOperator, IStochasticOperator, IIntegerVectorStdDevStrategyParameterCrossover {
+    public override bool CanChangeName {
+      get { return false; }
+    }
+    public ILookupParameter<IRandom> RandomParameter {
+      get { return (ILookupParameter<IRandom>)Parameters["Random"]; }
+    }
+    public ILookupParameter<ItemArray<DoubleArray>> ParentsParameter {
+      get { return (ILookupParameter<ItemArray<DoubleArray>>)Parameters["ParentStrategyParameter"]; }
+    }
+    public ILookupParameter<DoubleArray> StrategyParameterParameter {
+      get { return (ILookupParameter<DoubleArray>)Parameters["StrategyParameter"]; }
+    }
+
+    [StorableConstructor]
+    protected StdDevStrategyVectorCrossover(bool deserializing) : base(deserializing) { }
+    protected StdDevStrategyVectorCrossover(StdDevStrategyVectorCrossover original, Cloner cloner) : base(original, cloner) { }
+    public StdDevStrategyVectorCrossover()
+      : base() {
+      Parameters.Add(new LookupParameter<IRandom>("Random", "The random number generator to use."));
+      Parameters.Add(new ScopeTreeLookupParameter<DoubleArray>("ParentStrategyParameter", "The strategy parameters to cross."));
+      Parameters.Add(new LookupParameter<DoubleArray>("StrategyParameter", "The crossed strategy parameter."));
+      ParentsParameter.ActualName = "StrategyParameter";
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new StdDevStrategyVectorCrossover(this, cloner);
+    }
+
+    public override IOperation Apply() {
+      StrategyParameterParameter.ActualValue = Average(RandomParameter.ActualValue, ParentsParameter.ActualValue);
+      return base.Apply();
+    }
+
+    private DoubleArray Average(IRandom random, ItemArray<DoubleArray> parents) {
+      int length = parents[0].Length;
+      var result = new DoubleArray(length);
+      for (int i = 0; i < length; i++) {
+        for (int p = 0; p < parents.Length; p++) {
+          result[i] += parents[p][i];
+        }
+        result[i] /= parents.Length;
+      }
+      return result;
+    }
+  }
+}
Index: branches/GP-MoveOperators/HeuristicLab.Encodings.IntegerVectorEncoding/3.3/StrategyParameters/StdDevStrategyVectorManipulator.cs
===================================================================
--- branches/GP-MoveOperators/HeuristicLab.Encodings.IntegerVectorEncoding/3.3/StrategyParameters/StdDevStrategyVectorManipulator.cs	(revision 8206)
+++ branches/GP-MoveOperators/HeuristicLab.Encodings.IntegerVectorEncoding/3.3/StrategyParameters/StdDevStrategyVectorManipulator.cs	(revision 8206)
@@ -0,0 +1,113 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Operators;
+using HeuristicLab.Optimization;
+using HeuristicLab.Parameters;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.Random;
+
+namespace HeuristicLab.Encodings.IntegerVectorEncoding {
+  /// <summary>
+  /// Mutates the endogenous strategy parameters.
+  /// </summary>
+  [Item("StdDevStrategyVectorManipulator", "Mutates the endogenous strategy parameters.")]
+  [StorableClass]
+  public class StdDevStrategyVectorManipulator : SingleSuccessorOperator, IStochasticOperator, IIntegerVectorStdDevStrategyParameterManipulator {
+    public override bool CanChangeName {
+      get { return false; }
+    }
+    public ILookupParameter<IRandom> RandomParameter {
+      get { return (ILookupParameter<IRandom>)Parameters["Random"]; }
+    }
+    public ILookupParameter<DoubleArray> StrategyParameterParameter {
+      get { return (ILookupParameter<DoubleArray>)Parameters["StrategyParameter"]; }
+    }
+    public IValueLookupParameter<DoubleValue> GeneralLearningRateParameter {
+      get { return (IValueLookupParameter<DoubleValue>)Parameters["GeneralLearningRate"]; }
+    }
+    public IValueLookupParameter<DoubleValue> LearningRateParameter {
+      get { return (IValueLookupParameter<DoubleValue>)Parameters["LearningRate"]; }
+    }
+    public IValueLookupParameter<DoubleMatrix> BoundsParameter {
+      get { return (IValueLookupParameter<DoubleMatrix>)Parameters["Bounds"]; }
+    }
+
+    [StorableConstructor]
+    protected StdDevStrategyVectorManipulator(bool deserializing) : base(deserializing) { }
+    protected StdDevStrategyVectorManipulator(StdDevStrategyVectorManipulator original, Cloner cloner) : base(original, cloner) { }
+    public StdDevStrategyVectorManipulator()
+      : base() {
+      Parameters.Add(new LookupParameter<IRandom>("Random", "The random number generator to use."));
+      Parameters.Add(new LookupParameter<DoubleArray>("StrategyParameter", "The strategy parameter to manipulate."));
+      Parameters.Add(new ValueLookupParameter<DoubleValue>("GeneralLearningRate", "The general learning rate (tau0)."));
+      Parameters.Add(new ValueLookupParameter<DoubleValue>("LearningRate", "The learning rate (tau)."));
+      Parameters.Add(new ValueLookupParameter<DoubleMatrix>("Bounds", "A 2 column matrix specifying the lower and upper bound for each dimension. If there are less rows than dimension the bounds vector is cycled.", new DoubleMatrix(new double[,] { { 0, 5 } })));
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new StdDevStrategyVectorManipulator(this, cloner);
+    }
+
+    /// <summary>
+    /// Mutates the endogenous strategy parameters.
+    /// </summary>
+    /// <param name="random">The random number generator to use.</param>
+    /// <param name="vector">The strategy vector to manipulate.</param>
+    /// <param name="generalLearningRate">The general learning rate dampens the mutation over all dimensions.</param>
+    /// <param name="learningRate">The learning rate dampens the mutation in each dimension.</param>
+    /// <param name="bounds">The minimal and maximal value for each component, bounds are cycled if the length of bounds is smaller than the length of vector</param>
+    public static void Apply(IRandom random, DoubleArray vector, double generalLearningRate, double learningRate, DoubleMatrix bounds) {
+      NormalDistributedRandom N = new NormalDistributedRandom(random, 0.0, 1.0);
+      double generalMultiplier = Math.Exp(generalLearningRate * N.NextDouble());
+      for (int i = 0; i < vector.Length; i++) {
+        double change = vector[i] * generalMultiplier * Math.Exp(learningRate * N.NextDouble());
+        if (bounds != null) {
+          double min = bounds[i % bounds.Rows, 0], max = bounds[i % bounds.Rows, 1];
+          if (min == max) vector[i] = min;
+          else {
+            if (change < min || change > max) change = Math.Max(min, Math.Min(max, change));
+            vector[i] = change;
+          }
+        }
+      }
+    }
+    /// <summary>
+    /// Mutates the endogenous strategy parameters.
+    /// </summary>
+    /// <remarks>Calls <see cref="OperatorBase.Apply"/> of base class <see cref="OperatorBase"/>.</remarks>
+    /// <inheritdoc select="returns"/>
+    public override IOperation Apply() {
+      var strategyParams = StrategyParameterParameter.ActualValue;
+      if (strategyParams != null) { // only apply if there is a strategy vector
+        IRandom random = RandomParameter.ActualValue;
+        double tau0 = GeneralLearningRateParameter.ActualValue.Value;
+        double tau = LearningRateParameter.ActualValue.Value;
+        Apply(random, strategyParams, tau0, tau, BoundsParameter.ActualValue);
+      }
+      return base.Apply();
+    }
+  }
+}
